#ifndef __NET_INC_PRINTUTILS__

#define __NET_INC_PRINTUTILS__

#include <winsock2.h>
#include <iphlpapi.h>
#include <ws2tcpip.h>

//
// IP structure.
// see. Gary R. Wright et al, "TCP/IP Illustrated, Vol 2" p.211, Addison Wesley, 1995
//

typedef struct IP_HEADER {

	unsigned char ip_vhl; // version and header length

#define ip_v ip_vhl>>4
#define ip_hl ip_vhl&0x0F

	unsigned char ip_tos; // type of service
	unsigned short ip_len; // total length
	unsigned short ip_id; // identification
	unsigned short ip_off; //fragment offset field

#define IP_DF 0x4000 //dont fragment flag
#define IP_MF 0x2000 //more fragment flag
#define IP_OFFMASK 0x1fff //mask for fragmenting bits

	unsigned char ip_ttl; // time to live
	unsigned char ip_p; //protocol
	unsigned short ip_sum; // checksum
	struct in_addr ip_src, ip_dst; // source and dest address

} IP_HEADER, *PIP_HEADER;	


typedef struct MY_TCPROW
{
	DWORD dwState;
	in_addr LocalAddr;
	SHORT sLocalPort;
	in_addr RemoteAddr;
	SHORT sRemotePort;

} MY_TCPROW, *PMY_TCPROW;


void PrintHexDump(DWORD length, PBYTE buffer);
VOID PrintTCPRow(PMIB_TCPROW pTcpRow);
VOID PrintAddrInfo(addrinfo* pAddrInfo);
VOID PrintIPHeader(IP_HEADER ip_header);


#endif
